LibreEtVous/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.contrib.flatpages import views as flatpages_views
from . import views as core_view

urlpatterns = [
    url(r'^$',
        flatpages_views.flatpage,
        {'url': '/index/'},
        name='site-index'),
    url(r'^accounts/register/$',
        core_view.SignInView.as_view(),
        name='signin'),
    url(r'^accounts/', include('registration.backends.default.urls')),
    url(r'^pages/', include('django.contrib.flatpages.urls')),
    url(r'^events/', include('kiss_events.urls')),
    url(r'^contact/', include('kiss_contact_us.urls')),
    url(r'^captcha/', include('captcha.urls')),
    url(r'^admin/', admin.site.urls),
]

kiss_events/urls.py
from django.conf.urls import url

from . import views


app_name = 'kiss_events'
urlpatterns = [
    url(r'^$',
        views.ScheduleView.as_view(),
        name='AcceptedEventsSchedule'),
    url(r'^(?P<pk>[0-9]+)/$',
        views.AcceptedEventDetailView.as_view(),
        name='AcceptedEventDetail'),
    url(r'^a-z/$',
        views.AcceptedEventsListView.as_view(),
        name='AcceptedEventsList'),
    url(r'^submit/$',
        views.EventSubmitView.as_view(),
        name='EventSubmit'),
    url(r'^submit/success$',
        views.EventSubmitSuccessView.as_view(),
        name='EventSubmitSuccess')
]

kiss_events/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils.translation import ugettext as _
from kiss_places.models import Place


class EventType(models.Model):
    "The type of an event"
    name = models.CharField(
        verbose_name=_('name'),
        max_length=255,
    )
    description = models.TextField(
        verbose_name=_('description'),
        blank=True,
    )

    class Meta:
        ordering = ('name',)
        verbose_name = _('event type')
        verbose_name_plural = _('event types')

    def __str__(self):
        return self.name


class Duration(models.Model):
    "How many time for an event"
    minutes = models.IntegerField(
        verbose_name=_('minutes'),
    )

    class Meta:
        ordering = ('minutes',)
        verbose_name = _('duration')
        verbose_name_plural = _('durations')

    def __str__(self):
        return str(self.minutes)


class Event(models.Model):
    "A Event (talk, a workshop, etc), with all his informations"
    ACCEPTED_CODE = 'Accepted'
    NOT_ACCEPTED_CODE = 'Not Accepted'
    CANCELLED_CODE = 'Cancelled'
    WAITING_CODE = 'Waiting'
    SUBMITTED_CODE = 'Submitted'
    STATUS = (
        (ACCEPTED_CODE, _('Accepted')),
        (NOT_ACCEPTED_CODE, _('Not Accepted')),
        (CANCELLED_CODE, _('Cancelled')),
        (WAITING_CODE, _('Waiting')),
        (SUBMITTED_CODE, _('Submitted')),
    )
    DEFAULT_STATUS = SUBMITTED_CODE
    title = models.CharField(
        verbose_name=_('title'),
        max_length=255
    )
    authors_list = models.CharField(
        verbose_name=_('authors list'),
        max_length=255,
        help_text=_(
            'Separate authors with comma.'
        )
    )
    contact = models.ForeignKey(
        User, verbose_name=_('contact'),
        on_delete=models.CASCADE,
        help_text=_(
            'Who submit this event.'
        )
    )
    type = models.ForeignKey(
        EventType, verbose_name=_('type'),
        on_delete=models.CASCADE,
        help_text=_(
            'The kind of this event.'
        )
    )
    duration = models.ForeignKey(
        Duration, verbose_name=_('duration (minutes)'),
        on_delete=models.CASCADE
    )
    abstract = models.TextField(verbose_name=_('abstract'))
    note_for_organizers = models.TextField(
        verbose_name=_('note for organizers'),
        blank=True, help_text=_('Private.')
    )
    status = models.CharField(
        verbose_name=_('status'),
        max_length=42, choices=STATUS,
        default=DEFAULT_STATUS
    )
    schedule = models.DateTimeField(
        verbose_name=_('schedule'),
        blank=True, null=True,
        help_text=_('When this event start')
    )
    place = models.ForeignKey(
        Place, verbose_name=_('take place at'),
        on_delete=models.SET_NULL,
        null=True, blank=True
    )
    video_recording_url = models.URLField(
        verbose_name=_('video recording url'),
        blank=True, null=True,
        max_length=255,
    )
    audio_recording_url = models.URLField(
        verbose_name=_('audio recording url'),
        blank=True, null=True,
        max_length=255,
    )
    slides_and_files_url = models.URLField(
        verbose_name=_('slides and files url'),
        blank=True, null=True,
        max_length=255,
    )

    def is_accepted(self):
        "Is this event accepted"
        return self.status == self.ACCEPTED_CODE
    is_accepted.short_description = _('is accepted')

    def is_scheduled(self):
        "Is this event scheduled"
        return True if self.schedule else False
    is_scheduled.short_description = _('is scheduled')

    is_accepted.boolean = True
    is_scheduled.boolean = True

    class Meta:
        ordering = ('title',)
        verbose_name = _('event')
        verbose_name_plural = _('events')

    def __str__(self):
        return self.title


class ExternalLink(models.Model):
    """An external link, attached to an event"""
    description = models.CharField(
        verbose_name=_('description'),
        max_length=255,
    )
    URL = models.URLField(
        verbose_name=_('URL'),
        max_length=255,
    )
    event = models.ForeignKey(
        Event,
        verbose_name=('event'),
        on_delete=models.CASCADE,
    )

    class Meta:
        ordering = ('description',)
        verbose_name = _('external link')
        verbose_name_plural = _('external links')

kiss_events/views.py
from django.views.generic import DetailView, ListView, base, edit
from django.conf import settings
from django.http import Http404
from django.urls import reverse_lazy
from django.contrib.auth.mixins import LoginRequiredMixin

from .models import Event


class AcceptedEventDetailView(DetailView):
    "Show public informations about an accepted event"
    model = Event

    def get_object(self, queryset=None):
        "To only show an accepted event"
        event = super(AcceptedEventDetailView,
                      self).get_object(queryset=queryset)
        if not event.is_accepted():
            raise Http404()
        return event


class AcceptedEventsListView(ListView):
    "Show the list of accepted events, sorted by title"
    model = Event
    queryset = Event.objects.filter(status='Accepted').order_by('title')

    def get_context_data(self, **kwargs):
        """
        Get the list of accepted and scheduled event.
        Grouped by day.
        """
        context = super(AcceptedEventsListView, self).get_context_data(
            **kwargs
        )
        try:
            program_in_prep = settings.PROGRAM_IN_PREPARATION
            context['program_in_preparation'] = program_in_prep
        except Exception:
            context['program_in_preparation'] = True
        return context


class ScheduleView(base.TemplateView):
    """
    Show the Schedule of the meeting.

    You get all the events, grouped by date, as a dictionnary in the context
    given to the template.
    This dictionary is called 'schedule'. It has dates (datetime.date)
    as keys and corresponding events (querrysets) as values.

    """
    template_name = 'kiss_events/schedule.html'

    def get_context_data(self, **kwargs):
        """
        Get the list of accepted and scheduled event.
        Grouped by day.
        """
        context = super(ScheduleView, self).get_context_data(**kwargs)
        # See if the program is in preparation
        try:
            program_in_prep = settings.PROGRAM_IN_PREPARATION
            context['program_in_preparation'] = program_in_prep
        except Exception:
            context['program_in_preparation'] = True
        schedule = {}
        # Get dates in the schedule
        events_schedules = Event.objects.filter(
            status='Accepted',
        ).values_list(
            'schedule', flat=True,
        )
        events_dates = set((schedule.date()
                            for schedule in events_schedules
                            if schedule))
        events_dates = sorted(events_dates)
        for ev_date in events_dates:
            group_events = Event.objects.filter(
                schedule__date=ev_date,
                status='Accepted',
            ).order_by('schedule')
            schedule[ev_date] = group_events
        context['schedule'] = schedule
        return context


class EventSubmitView(LoginRequiredMixin, edit.CreateView):
    "Let user submit an event"
    login_url = reverse_lazy('auth_login')
    model = Event
    fields = [
        'title',
        'authors_list',
        'type',
        'duration',
        'abstract',
        'note_for_organizers',
    ]
    success_url = reverse_lazy('kiss_events:EventSubmitSuccess')

    def form_valid(self, form):
        """
         Overload to indicate the user id as contact of the
         submited event.
        """
        form.instance.contact = self.request.user
        return super(EventSubmitView, self).form_valid(form)


class EventSubmitSuccessView(base.TemplateView):
    "If user succefully submited an event"
    template_name = 'kiss_events/event_form_success.html'

kiss_events/templates/kiss_events/base.html
{% load staticfiles %}
{% load menubuilder %}{% menu headernavigation %}
<!DOCTYPE HTML>
<html lang="fr">
  <head>
    <title>{% block title %}{% endblock %}</title>
    <meta name="author" content="{% block author %}{% endblock %}" />
    <meta name="description" content="{% block description %}{% endblock %}" />
    <meta charset="UTF-8"/>
    <link rel="stylesheet" href="{% static 'kiss_events/base-style.css' %}" type="text/css" media="screen" />
    {% block head %}{% endblock head %}
  </head>
  <body>
    <header>
      <h1><a href="/">Libre et vous</a></h1>
      <nav>
        {% for item in menuitems %}
	<a href="{{ item.url }}" title="{{ item.title|escape }}"{% if item.current %} class='current'{% endif %}>{{ item.title }}</a>
	{% endfor %}
      </nav>
      <div class="auth">
	{% if user.is_authenticated %}
	<a href="{%url 'auth_password_change' %}">Modifier mot de passe</a> / <a href="{%url 'auth_logout' %}">Se déconnecter</a>
	{% else %}
	<a href="{%url 'auth_login' %}">Se connecter</a>
	{% endif %}
      </div>
    </header>
    <div class="content">
    {% block content %}
    {% endblock %}      
    </div>
  </body>
</html>

kiss_events/templates/kiss_events/event_detail.html
{% extends 'base.html' %}
{% load i18n %}
{% load staticfiles %}
{% load tz %}

{% block head %}<link rel="stylesheet" href="{% static 'kiss_events/content-style.css' %}" type="text/css" media="screen" />{% endblock head %}

{% block title %}{{ event.title|capfirst }}{% endblock %}

{% block content %}
<div id="event-details">
  <div class="content-header">
    <h2>{{ event.title|capfirst }}</h2>
  </div>
  <div class="infos">
    <p class="subtitle"><strong>{% trans "Author(s)"%}</strong>: {{ event.authors_list }}</p>
    <ul class="metadatas">
      <li><strong>{% trans "Type" %}</strong>: {{ event.type }}</li>
      <li><strong>{% trans "Duration" %}</strong>: {{ event.duration }} {% trans "minutes" %}</li>
      {% if event.schedule %}
      <li><strong>{% trans "When" %}</strong>: {{ event.schedule|date:"d F" }} {% trans "at" %} {{ event.schedule|localtime|date:"H:i" }}</li>
      {% endif %}
      {% if event.place %}
      <li><strong>{% trans "Where" %}</strong>: {{ event.place }}</li>
      {% endif %}      
    </ul>
  </div>
  <div class="abstract">
    <h4>{% trans "Abstract" %}</h4>
    <p>{{ event.abstract }}</p>
  </div>
  {% if event.externallink_set.all %}
      <div class="external-links">
	  <h4>{% trans 'Links' %}</h4>
	  <ul class="external-links">
	      {% for external_link in event.externallink_set.all %}
		  <li><a href="{{ external_link.URL }}">{{ external_link.description }}</a></li>
	      {% endfor %}
	  </ul>
      </div>
  {% endif %}
  {% if event.video_recording_url or event.audio_recording_url %}
      <div class="records">
	  <h4>{% trans 'Recordings'%}</h4>
	  {% if event.video_recording_url %}
	      <h5>{% trans 'Video'%}</h5>
	      <div>
		  <div>
		      <video src="{{ event.video_recording_url }}" controls></video>
		  </div>
		  <a href="{{ event.video_recording_url }}" download>{% trans 'Download video recording' %}</a>
	      </div>
	  {% endif %}
	  {% if event.audio_recording_url %}
	      <h5>{% trans 'Audio'%}</h5>
	      <div>
		  <div>
		      <audio src="{{ event.audio_recording_url }}" controls></audio>
		  </div>
		  <a href="{{ event.audio_recording_url }}" download>{% trans 'Download audio recording' %}</a>
	      </div>
	  {% endif %}
      </div>
  {% endif %}
  {% if event.slides_and_files_url %}
      <div class="attachments">
	  <a href="event.slides_and_files_url" download>{% trans 'Slides and files' %}</a>
      </div>
  {% endif %}
</div>
{% endblock %}

kiss_events/templates/kiss_events/event_form.html
{% extends 'base.html' %}
{% load i18n %}
{% load staticfiles %}

{% block head %}<link rel="stylesheet" href="{% static 'kiss_events/content-style.css' %}" type="text/css" media="screen" />{% endblock head %}

{% block title %}{% trans 'Submit an event' %}{% endblock %}

{% block content %}
<div id="event-submit">
  <div class="content-header">
    <h2>{% trans 'Submit an event'%}</h2>
  </div>
  <form method="post" action="">
    {% csrf_token%}
    <table>
      {{ form.as_table }}
    </table>
    <input type="submit" name="submit" class="submit-button" value="{% trans 'Send' %}" />
  </form>
</div>
{% endblock %}

kiss_events/templates/kiss_events/event_form_success.html
{% extends 'base.html' %}
{% load i18n %}
{% load staticfiles %}

{% block head %}<link rel="stylesheet" href="{% static 'kiss_events/content-style.css' %}" type="text/css" media="screen" />{% endblock head %}

{% block title %}{% trans 'Submission registered' %}{% endblock %}

{% block content %}
<div id="event-submit-success">
  <div class="content-header">
    <h2>{% trans 'Thanks for your submission' %}</h2>    
  </div>
  <p>
    {% trans 'We have registered your submission. Your event will be visible after validation.' %} <br />
    {% trans 'We will contact you soon.'%}
  </p>
  <div id="return">
    {% trans 'Return to' %}:
    <ul>
      <li><a href="{% url 'kiss_events:AcceptedEventsSchedule' %}">{% trans 'Schedule' %}</a></li>
      <li><a href="{% url 'kiss_events:AcceptedEventsList' %}">{% trans 'All events A-Z' %}</a></li>
    </ul>
  </div>
</div>
{% endblock %}

kiss_events/templates/kiss_events/event_list.html
{% extends 'base.html' %}
{% load i18n %}
{% load staticfiles %}
{% load tz %}

{% block head %}<link rel="stylesheet" href="{% static 'kiss_events/content-style.css' %}" type="text/css" media="screen" />{% endblock head %}

{% block title %}{% trans 'All events A-Z' %}{% endblock %}

{% block content %}
<div id="events-list">
  <div class="content-header">
    <h2>{% trans "All events A-Z"%}</h2>
    <ul class="content-options">
      <li><a href="{% url 'kiss_events:EventSubmit' %}">{% trans "Submit an event" %}</a></li>
      <li><a href="{% url 'kiss_events:AcceptedEventsSchedule' %}">{% trans "Schedule" %}</a></li>
    </ul>    
  </div>
  {% if program_in_preparation %}
  <div class="message">
    <p>{% trans 'The program is being prepared' %}</p>
  </div>
  {% endif %}
  {% if object_list %}
  <table class="events-table">
    <thead>
      <tr>
        <th>{% trans "Title" %}</th>
	<th>{% trans "Author(s)" %}</th>
	<th>{% trans "Type" %}</th>
	<th>{% trans "Duration (minutes)" %}</th>
	<th>{% trans "Schedule" %}</th>
	<th>{% trans "Place" %}</th>
      </tr>
    </thead>
    <tbody>
      {% for event in object_list %}
      <tr>
        <td><a href="{% url 'kiss_events:AcceptedEventDetail' event.id %}">{{ event.title|capfirst }}</a></td>
	<td>{{ event.authors_list }}</td>
	<td>{{ event.type }}</td>
	<td>{{ event.duration }}</td>
	{% if event.schedule %}
	<td>{{ event.schedule|localtime|date:"d F H:i" }}</td>
	{% else %}
	<td>-</td>
	{% endif %}
	{% if event.place %}
	<td>{{ event.place }}</td>
	{% else %}
	<td>-</td>
	{% endif %}
      </tr>
      {% endfor %}
    </tbody>
  </table>
  {% endif %}
</div>
{% endblock %}

kiss_events/templates/kiss_events/schedule.html
{% extends 'base.html' %}
{% load i18n %}
{% load staticfiles %}
{% load tz %}

{% block head %}<link rel="stylesheet" href="{% static 'kiss_events/content-style.css' %}" type="text/css" media="screen" />{% endblock head %}

{% block title %}{% trans 'Events schedule' %}{% endblock %}

{% block content %}
<div id="schedule">
  <div class="content-header">
    <h2>{% trans "Schedule" %}</h2>
    <ul class="content-options">
      <li><a href="{% url 'kiss_events:EventSubmit' %}">{% trans "Submit an event" %}</a></li>
      <li><a href="{% url 'kiss_events:AcceptedEventsList' %}">{% trans "A-Z" %}</a></li>
    </ul>    
  </div>
  {% if program_in_preparation %}
  <div class="message">
    <p>{% trans 'The program is being prepared' %}</p>
  </div>
  {% endif %}
  {% for ev_date, events_list in schedule.items %}
  <div class="day">
    <h3>{{ ev_date|date:"d F" }}</h3>
    <ul>
      {% for event in events_list %}
      <li>
	<a href="{% url 'kiss_events:AcceptedEventDetail' event.id %}">
	  <span class="event-schedule">{{ event.schedule|localtime|date:"H:i" }}</span>
	  <span class="event-title"> - {{ event.title|capfirst }}</span>
	  <span class="event-authors">{% trans "by" %} {{ event.authors_list }}</span>
	  <span class="event-infos">({{ event.type }}, {{ event.duration }} {% trans "minutes" %})</span>
	</a>
      </li>
      {% endfor %}
    </ul>
  </div>
  {% endfor %}
</div>
{% endblock %}